import { Component, Input, Optional, OnInit } from '@angular/core';
import { FormGroup, FormGroupName, ControlContainer } from '@angular/forms';
import { KeysPipe } from '@pipes/keys.pipe';

@Component({
	selector: 'app-dynaform',
	templateUrl: './dynaform.component.html',
	styleUrls: ['./dynaform.component.scss'],
	providers: [ KeysPipe ]
})
export class DynaformComponent implements OnInit {

	@Input()
	formGroup?: FormGroup;

	@Input()
	formGroupName?: FormGroupName;

	@Input()
	set meta(val) {
		this.formMetaData = val;
	}

	formMetaData: any; // TODO: Tighten up type
	controlNames: Array<string>;

	constructor(
		@Optional() private cc: ControlContainer
	) {}

	ngOnInit() {
		console.log('Dynaform Component');
		if (this.formGroup) {
			console.log('Initailised with FormGroup dirtectly: Controls >');
			console.log(Object.keys(this.formGroup.controls));
		}
		if (this.formGroupName) {
			console.log('Initailised with FormGroupName:', this.formGroupName);
			this.formGroup = <FormGroup>this.cc.control; // Get the associated formGroup from the ControlContainer
			console.log('Loading Controls from ControlContainer >');
			console.log(Object.keys(this.formGroup.controls));
		}
		if (!this.formGroup) {
			throw new Error('Dynaform Component Initialised without [formGroup] or formGroupName');
		}

	}

}
